import easytrader
import time
import os

"""
需要32位python
"""


class RealTrader:
    def __init__(self):
        self._ACCOUNT = os.environ.get("ACCOUNT")
        self._PASSWORD = os.environ.get("PASSWORD")
        self._exe_path = r"C:\\ths\\xiadan.exe"
        pass

    def login(self):
        print("准备登录:", self._ACCOUNT, self._PASSWORD)
        # self.trader = easytrader.use("universal_client")
        self.trader = easytrader.use("ths5.19")
        # 使用修改版交易客户端时, 不会超时
        try:
            self.trader.enable_type_keys_for_editor()
            self.trader.prepare(
                user=self._ACCOUNT, password=self._PASSWORD, exe_path=self._exe_path
            )
        except Exception as e:
            time.sleep(1)

    def logout(self):
        self.trader.exit()

    def get_balance(self):
        return self.trader.balance

    def get_positions(self):
        return self.trader.position

    # 查询当日成交
    def get_today_trades(self):
        return self.trader.today_trades

    # 查询当日委托
    def get_today_entrust(self):
        return self.trader.today_entrusts

    # 刷新数据
    def refresh(self):
        self.trader.refresh()

    def buy(self, code, price, amount):
        return self.trader.buy(code, price, amount)

    def sell(self, code, price, amount):
        return self.trader.sell(code, price, amount)

    def cancel(self, entrust_no):
        return self.trader.cancel_entrust(entrust_no)


if __name__ == "__main__":
    # 创建RealTrader实例
    trader = RealTrader()
    
    try:
        # 测试登录
        print("正在登录...")
        trader.login()
        print("登录成功!")
        
        # 获取账户余额测试
        balance = trader.get_balance()
        print("账户余额信息:", balance)

        # 获取持仓信息
        positions = trader.get_positions()
        print("持仓信息:", positions)

        # 获取当日成交
        today_trades = trader.get_today_trades()
        print("当日成交:", today_trades)

        # 获取当日委托
        today_entrust = trader.get_today_entrust()
        print("当日委托:", today_entrust)

        # 刷新数据
        trader.refresh()
        print("数据已刷新")
        
    except Exception as e:
        print("发生错误:", str(e))
    # finally:
    #     # 确保退出登录
    #     try:
    #         trader.logout()
    #         print("已安全退出!")
    #     except:
    #         pass
